package com.bjsxt.realms;

import java.net.ConnectException;
import java.security.interfaces.RSAKey;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.shiro.authc.AuthenticationException;
import org.apache.shiro.authc.AuthenticationInfo;
import org.apache.shiro.authc.AuthenticationToken;
import org.apache.shiro.authc.SimpleAuthenticationInfo;
import org.apache.shiro.realm.AuthenticatingRealm;
import org.apache.shiro.util.ByteSource;

import com.mysql.jdbc.Driver;

public class CustomRealm extends AuthenticatingRealm {

	private String principal;
	private String credentials;
	private ResultSet rs;
	private Statement state;
	private Connection conn;
	private String salt;

	@Override
	protected AuthenticationInfo doGetAuthenticationInfo(AuthenticationToken token) throws AuthenticationException {
		//ʹJDBC,ݿȡ
		try {
			//1.ע
			Driver driver = new Driver();
			DriverManager.registerDriver(driver);
			//2.ȡӶ
			String url ="jdbc:mysql:///test";
			String user = "root";
			String password = "1234";
			conn = DriverManager.getConnection(url , user , password );
			state = conn.createStatement();
			//4.ִsql
			String sql = "select userName,passwd,passwd_salt from starLogin";
			rs = state.executeQuery(sql );
			//5.
			while (rs.next()) {
				principal = rs.getString("userName");
				credentials = rs.getString("passwd");
				salt = rs.getString("passwd_salt");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}finally{
			if(rs != null){
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
			if(state != null){
				try {
					state.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
			if(conn != null){
				try {
					conn.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}
		
		ByteSource newSalt = ByteSource.Util.bytes(salt);
		SimpleAuthenticationInfo simpleAuthenticationInfo = new SimpleAuthenticationInfo(principal, credentials,newSalt , "customRealm");
		return simpleAuthenticationInfo;
	}

	
}
